#include <bits/stdc++.h>

using namespace std;

const int maxn = 1005;

int n;

int a[maxn];

vector<int> g[maxn];

int depth[maxn];

int idx = 0;
int stick[maxn];

void dfs2(int node, int par, int d)
{
    stick[++idx] = node;
    depth[node] = d;

    for (auto next_node : g[node])
    {
        if (next_node != par)
        {
            dfs2(next_node, node, d + 1);
        }
    }
}

int ans = 0;
int curr_node = -1;

int tree[4 * maxn];

void build(int node, int l, int r)
{
    if (l == r)
    {
        tree[node] = a[l];
        return;
    }

    int mid = (l + r) / 2;

    build(2 * node, l, mid);
    build(2 * node + 1, mid + 1, r);

    tree[node] = __gcd(tree[2 * node], tree[2 * node + 1]);
}

int query(int node, int l, int r, int ql, int qr)
{
    if (l > qr || r < ql)
    {
        return 0;
    }

    if (ql <= l && r <= qr)
    {
        return tree[node];
    }

    int mid = (l + r) / 2;

    return __gcd(query(2 * node, l, mid, ql, qr), query(2 * node + 1, mid + 1, r, ql, qr));
}

int dp[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    dfs2(1, -1, 0);

    build(1, 1, n);

    for (int i = 1; i <= n; ++i)
    {
        int l = i + 1;
        int r = n;

        while (l <= r)
        {
            int mid = (l + r) / 2;

            if (query(1, 1, n, i, mid) != 1)
            {
                l = mid + 1;
            }
            else
            {
                r = mid - 1;
            }
        }

        ans = max(ans, depth[r] - depth[i]);
    }

    cout << ans << endl;

    return 0;
}
