#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;
const int logn = 19;

int n;

int a[maxn];

vector<int> g[maxn];

int depth[maxn];

int idx = 0;
int stick[maxn];

int jump[maxn][logn];
int gcd[maxn][logn];

void dfs2(int node, int par, int d)
{
    stick[++idx] = node;
    depth[node] = d;
    gcd[node][0] = a[node];

    for (auto next_node : g[node])
    {
        if (next_node != par)
        {
            jump[next_node][0] = node;
            dfs2(next_node, node, d + 1);
        }
    }
}

int liftind(int from, int lift)
{
    int res = 0;

    for (int i = 18; i >= 0; --i)
    {
        if ((lift & (1 << i)) != 0)
        {
            res = __gcd(res, gcd[from][i]);
            from = jump[from][i];
            lift -= (1 << i);
        }
    }

    return __gcd(res, gcd[from][0]);
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    dfs2(1, -1, 0);

    jump[1][0] = 1;

    for (int i = 1; i < logn; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            jump[j][i] = jump[jump[j][i - 1]][i - 1];
            gcd[j][i] = __gcd(gcd[j][i - 1], gcd[jump[j][i - 1]][i - 1]);
        }
    }

    int ans = 0;

    for (int i = 2; i <= n; ++i)
    {
        int l = 0;
        int r = depth[i];

        while (l <= r)
        {
            int mid = (l + r) / 2;

            //cout << i << ' ' << mid << ' ' << liftind(i, mid) << endl;

            if (liftind(i, mid) != 1)
            {
                l = mid + 1;
            }
            else
            {
                r = mid - 1;
            }
        }

        //cout << "for " << i << " -> " << r << endl;

        ans = max(ans, r);
    }

    cout << ans << endl;

    return 0;
}
/*
8
7 7 7 3 3 3 3 7
1 2
1 3
2 4
2 5
2 6
3 7
7 8
*/
