#include <bits/stdc++.h>

using namespace std;

const int maxn = 705;
const int inf = (1LL << 30);

int n, k;

int a[maxn][maxn];
int p[maxn][maxn];

int calc(int x1, int y1, int x2, int y2)
{
    return p[x2][y2] - p[x1 - 1][y2] - p[x2][y1 - 1] + p[x1 - 1][y1 - 1];
}

int dp[maxn][maxn][maxn];

int f(int lamps, int last_start, int last_end)
{
    if (lamps == 0 || last_start == n)
    {
        return 0;
    }

    if (dp[lamps][last_start][last_end] != -inf)
    {
        return dp[lamps][last_start][last_end];
    }

    int result = -inf;

    for (int i = last_start + 1; i <= n; ++i)
    {
        for (int j = last_end + 1; j <= n; ++j)
        {
            int curr = calc(i, i, j, j);

            if (i <= last_end)
            {
                curr -= calc(i, i, last_end, last_end);
            }

            result = max(result, curr + f(lamps - 1, i, j));
        }
    }

    return dp[lamps][last_start][last_end] = result;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> k;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            cin >> a[i][j];
            p[i][j] = p[i - 1][j] + p[i][j - 1] + a[i][j] - p[i - 1][j - 1];
        }
    }

    for (int i = 0; i < maxn; ++i)
    {
        for (int j = 0; j < maxn; ++j)
        {
            for (int k = 0; k < maxn; ++k)
            {
                dp[i][j][k] = -inf;
            }
        }
    }

    cout << f(k, 0, 0) << endl;

    return 0;
}
/*
8 4
12 -3 3 -9 0 2 3 -4
-11 3 -5 1 -6 1 -7 7
 4 -8 1 4 -8 2 3 -5
 6 6 -6 1 10 -4 -4 4
 1 0 -8 -5 9 5 -3 -11
2 -2 6 7 -4 8 6 2
-5 -7 4 0 9 -1 -1 9
-10 4 1 -7 4 -5 6 7
*/
